SPOJ 220 Relevant Phrases of Annihilation (后缀数组)

题目大意:

求在m个串中同时出现两次以上且不覆盖的子串的长度。

思路分析:

二分答案,然后check是否满足,判断不覆盖的方法就是用up down 来处理边界。

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <map>
#include <string>
#define maxn 110005
using namespace std;

char str[maxn];
int sa[maxn],t1[maxn],t2[maxn],c[maxn],n;
void suffix(int m)
{
    int *x=t1,*y=t2;
    for(int i=0; i<m; i++)c[i]=0;
    for(int i=0; i<n; i++)c[x[i]=str[i]]++;
    for(int i=1; i<m; i++)c[i]+=c[i-1];
    for(int i=n-1; i>=0; i--)sa[--c[x[i]]]=i;
    for(int k=1; k<=n; k<<=1)
    {
        int p=0;
        for(int i=n-k; i<n; i++)y[p++]=i;
        for(int i=0; i<n; i++)if(sa[i]>=k)y[p++]=sa[i]-k;
        for(int i=0; i<m; i++)c[i]=0;
        for(int i=0; i<n; i++)c[x[y[i]]]++;
        for(int i=0; i<m; i++)c[i]+=c[i-1];
        for(int i=n-1; i>=0; i--)sa[--c[x[y[i]]]]=y[i];
        swap(x,y);
        p=1;
        x[sa[0]]=0;
        for(int i=1; i<n; i++)
            x[sa[i]]=y[sa[i-1]]==y[sa[i]]&&y[sa[i-1]+k]==y[sa[i]+k]?p-1:p++;
        if(p>=n)break;
        m=p;
    }
}
int rank[maxn],height[maxn];
void getheight()
{
    int k=0;
    for(int i=0; i<n; i++)rank[sa[i]]=i;
    for(int i=0; i<n; i++)
    {
        if(k)k--;
        if(!rank[i])continue;
        int j=sa[rank[i]-1];
        while(str[i+k]==str[j+k])k++;
        height[rank[i]]=k;
    }
}

int dex[maxn];
int cnt[11];
char tmp[maxn];
int len[maxn];
int up[11];
int down[11];

bool ok(int len,int m)
{
    for(int i=1;i<=m;i++)
    if(up[i]-down[i]<len)return false;
    return true;
}
bool check(int len,int m)
{
    memset(up,-1,sizeof up);
    memset(down,-1,sizeof down);
    for(int i=1;i<n;i++)
    {
        if(height[i]<len)
        {
            if(ok(len,m))return true;
            memset(up,-1,sizeof up);
            memset(down,-1,sizeof down);
            int index=dex[sa[i]];
            up[index]=down[index]=sa[i];
        }
        else
        {
            int index=dex[sa[i]];
            if(up[index]!=-1){
                up[index]=max(up[index],sa[i]);
                down[index]=min(down[index],sa[i]);
            }
            else up[index]=down[index]=sa[i];
        }
    }
    return false;
}
int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        n=0;
        int m;
        scanf("%d",&m);
        for(int i=1;i<=m;i++)
        {
            scanf("%s",tmp);
            len[i]=strlen(tmp);
            for(int j=n;j<len[i]+n;j++)
            {
                str[j]=tmp[j-n];
                dex[j]=i;
            }
            n+=len[i]+1;
            str[n-1]=i+'A';
            dex[n-1]=i;
        }
        str[n-1]=0;

        suffix(256);
        getheight();

        int l=1,r=10000,ans=0;
        while(l<=r)
        {
            int mid=(l+r)>>1;
            if(check(mid,m))
            ans=mid,l=mid+1;
            else r=mid-1;
        }
        printf("%d\n",ans);
    }
    return 0;
}

SPOJ 220 Relevant Phrases of Annihilation (后缀数组),布布扣,bubuko.com

时间: 2024-11-02 03:32:36

SPOJ 220 Relevant Phrases of Annihilation (后缀数组)的相关文章

SPOJ 220. Relevant Phrases of Annihilation(后缀数组多次不重叠子串)

题目大意:给定N个串,求每个串至少出现两次的最长子串. 解题思路:每个字符串至少出现两次且不可重叠的最长子串:二分枚举长度后在同一分组中对每一个字符串保留一个最小的位置和一个最大的位置,最后查看是否每个串在同一组中都有至少两个后缀,并且后缀的坐标差大于枚举的长度. POJ Problem Set (classical) 220. Relevant Phrases of Annihilation Problem code: PHRASES You are the King of Byteland.

SPOJ 220 Relevant Phrases of Annihilation(后缀数组+二分答案)

[题目链接] http://www.spoj.pl/problems/PHRASES/ [题目大意] 求在每个字符串中出现至少两次的最长的子串 [题解] 注意到这么几个关键点:最长,至少两次,每个字符串. 首先对于最长这个条件,我们可以想到二分答案, 然后利用后缀数组所求得的三个数组判断是否满足条件. 其次是出现两次,每次出现这个条件的时候, 我们就应该要想到这是最大值最小值可以处理的, 将出现在同一个字符串中的每个相同字符串的起始位置保存下来, 如果最小值和最大值的差距超过二分长度L,则表明在

SPOJ220 Relevant Phrases of Annihilation(后缀数组)

引用罗穗骞论文中的话: 先将n 个字符串连起来,中间用不相同的且没有出现在字符串中的字符隔开,求后缀数组.然后二分答案,再将后缀分组.判断的时候,要看是否有一组后缀在每个原来的字符串中至少出现两次,并且在每个原来的字符串中,后缀的起始位置的最大值与最小值之差是否不小于当前答案(判断能否做到不重叠,如果题目中没有不重叠的要求,那么不用做此判断).这个做法的时间复杂度为O(nlogn). 二分枚举长度,对每个长度遍历height[]数组,将height[]数组分块,每个块内任意两串的lcp均大于等于

SPOJ - PHRASES Relevant Phrases of Annihilation (后缀数组)

You are the King of Byteland. Your agents have just intercepted a batch of encrypted enemy messages concerning the date of the planned attack on your island. You immedietaly send for the Bytelandian Cryptographer, but he is currently busy eating popc

SPOJ220 Relevant Phrases of Annihilation

http://www.spoj.com/problems/PHRASES/ 题意:给n个串,求n个串里面都有2个不重叠的最长的字串长度. 思路:二分答案,然后就可以嘿嘿嘿 PS:辣鸡题目毁我青春,一开始二分的时候ans没有赋初值为0,结果没答案的时候就会输出奇怪的数字T_T,其实主要还是怪我不小心.. 1 #include<cstdio> 2 #include<iostream> 3 #include<cmath> 4 #include<cstring> 5

【SPOJ220】Relevant Phrases of Annihilation(后缀数组,二分)

题意: n<=10,len<=1e4 思路: 1 #include<cstdio> 2 #include<cstring> 3 #include<string> 4 #include<cmath> 5 #include<iostream> 6 #include<algorithm> 7 #include<map> 8 #include<set> 9 #include<queue> 10

SPOJ PHRASES Relevant Phrases of Annihilation

这道题注意要是不重叠的,一开始这里WA了一次 其他的思路应该挺简单的 #include<stdio.h> #include<algorithm> #include<string.h> using namespace std; #define N 100100 int r[N]; char s[11][10005]; int wa[N],wb[N],wv[N],ws[N]; int sa[N],rank[N],height[N]; int m[N]; int cmp(in

SPOJ SUBST1 POJ 2406 POJ REPEATS 后缀数组小结

//聪神说:做完了题目记得总结,方便以后复习. SPOJ SUBST1 题目链接:点击打开链接 题意:给一个字符串,求不同子串个数. 思路:假设所有子串都不同,答案为len*(len+1)/2;然而不是这样... 下面我们就找出重复的子串: 首先先将后缀排序,对于后缀i能生成len-sa[i]个子串,这其中有height[i]个子串与第i-1个后缀生成的子串重复了: 所以答案为 len*(len+1)/2-segema(height[i]) . cpp代码: //spoj disubstr #i

SPOJ 题目694 Distinct Substrings(后缀数组,求不同的子串个数)

DISUBSTR - Distinct Substrings no tags Given a string, we need to find the total number of its distinct substrings. Input T- number of test cases. T<=20; Each test case consists of one string, whose length is <= 1000 Output For each test case output